time={more=1,less=-1,equal=0}
time.eudst={}
time.eundst={}

function time.daysinamonth(Year,Month)
	if Month==1 then return 31
	elseif (Month==2) and IsLeap(Year) then return 29
	elseif Month==2 then return 28
	elseif Month==3 then return 31
	elseif Month==4 then return 30
	elseif Month==5 then return 31
	elseif Month==6 then return 30
	elseif Month==7 then return 31
	elseif Month==8 then return 31
	elseif Month==9 then return 30
	elseif Month==10 then return 31
	elseif Month==11 then return 30
	elseif Month==12 then return 31
	end
end

function time.PrintDate(date)
	print(string.format("%.2d/%.2d/%.4d %.2d:%.2d",date.Day,date.Month,date.Year,date.Hour,date.Minute))
	end

function time.IsLeap(Year)
--see if a year is a leap year
if (math.band(Year,3))~=0 then return false
	end
if math.mod(Year, 100)==0 then
	if math.mod(Year, 400)==0 then return true 
		else return false
		end
	else return true
	end
end

function time.GetDay(date)
	--find the day of a date
	local MonthCodes={0,3,3,6,1,4,6,2,5,0,3,5}
	local dayno
	dayno=math.mod(date.Year, 100);
    dayno=dayno+math.floor(dayno / 4)+MonthCodes[date.Month]+date.Day;
	dayno=dayno-math.mod(math.floor(date.Year/100),4)*2;
	if time.IsLeap(date.Year) and ((date.Month==1)or(date.Month==2)) then dayno=dayno-1 end
    dayno=math.mod(dayno, 7);
	if dayno<0 then dayno=-dayno;end;
	if dayno==0 then dayno=7;end;
	dayno=dayno-1
	return dayno;
	end

--get current time
local curtime=os.date("!*t")
if (curtime.month>=4)and(curtime.month<=10) then
   time.eudst.Year=curtime.year+1;
   time.eundst.Year=curtime.year;
   else
	time.eudst.Year=curtime.year;
	time.eundst.Year=curtime.year+1;
    end
--dst starts on last sunday in march and ends on last sunday in october
time.eudst.Month=3;
time.eudst.Day=31;
time.eundst.Month=10;
time.eundst.Day=31;
time.eudst.Day=time.eudst.Day-time.GetDay(time.eudst);
time.eundst.Day=time.eundst.Day-time.GetDay(time.eundst);
time.eundst.Hour=2;
time.eundst.Minute=0;
time.eundst.Second=0;
time.eudst.Hour=2;
time.eudst.Minute=0;
time.eudst.Second=0;

time.comp = function (date1,date2)
	if date1.Year<date2.Year then return time.less;end
	if date1.Year>date2.Year then return time.more;end
	if date1.Month<date2.Month then return time.less;end
	if date1.Month>date2.Month then return time.more;end
	if date1.Day<date2.Day then return time.less;end
	if date1.Day>date2.Day then return time.more;end
	if date1.Hour<date2.Hour then return time.less;end
	if date1.Hour>date2.Hour then return time.more;end
	if date1.Minute<date2.Minute then return time.less;end
	if date1.Minute>date2.Minute then return time.more;end
	if date1.Second<date2.Second then return time.less;end
	if date1.Second>date2.Second then return time.more;end
	return time.equal
	end

time.IsEUDST = function (date)
	if (date.Month>=4)and(date.Month<=9) then return true;end
	if (date.Month>=11)and(date.Month<=2) then return true;end
	if (date.Month==3) then
		if date.Day<time.eudst.Day then return false
		elseif date.Day>time.eudst.Day then return true
		elseif date.Hour>=time.eudst.Hour then return true
		end
		return false;
		end
	if (date.Month==10) then
		if date.Day<time.eundst.Day then return true
		elseif date.Day>time.eundst.Day then return false
		elseif date.Hour>=time.eundst.Hour then return false
		end
		return true;
		end	
	end
	
time.Fix = function (date)
while date.Second>=60 do
      date.Minute=date.Minute+1;
      date.Second=date.Second-60;
      end;
while date.Second<0 do 
      date.Minute=date.Minute-1;
      date.Second=date.Second+60;
      end;

while date.Minute>=60 do
      date.Hour=date.Hour+1;
      date.Minute=date.Minute-60;
      end;
while date.Minute<0 do
      date.Hour=date.Hour-1;
      date.Minute=date.Minute+60;
      end;

while date.Hour>=24 do 
      date.Day=date.Day+1;
      date.Hour=date.Hour-24;
      end;
while date.Hour<0 do 
      date.Day=date.Day-1;
      date.Hour=date.Hour+24;
      end;

while date.Day>time.daysinamonth(date.Year,date.Month) do
      date.Day=date.Day-time.daysinamonth(date.Year,date.Month);
      date.Month=date.Month+1;
      end;
while date.Day<=0 do
      date.Month=date.Month-1;
      date.Day=date.Day+time.daysinamonth(date.Year,date.Month);
      end;

while date.Month>12 do
      date.Month=date.Month-12;
      date.Year=date.Year+1;
      end;
while date.Month<=0 do
      date.Month=date.Month+12;
      date.Year=date.Year-1;
      end;
return date
end
	